deferred class
	AST_EIFFEL_FEATURE

inherit
	AST_DECLARATION
		redefine
			make_copy
		end
	ATTRIBUTE_SPECIFIER_INFO
		redefine
			make_copy
		end

feature {ANY}

	orig_c_identifier: STRING

	type: AST_TYPE
		deferred
		end

	storage_class_specifiers: LIST [INTEGER]

	is_extern: BOOLEAN
		do
			Result := storage_class_specifiers.has (C_kw_extern)
		end

feature {ANY}

	oo_feature: OO_FEATURE assign set_oo_feature

	set_oo_feature (a_oo_feature: OO_FEATURE)
		do
			oo_feature := a_oo_feature
		end

feature {ANY} -- AST_NODE

	make_copy (a_other: like Current)
		do
			Precursor {AST_DECLARATION} (a_other)
			Precursor {ATTRIBUTE_SPECIFIER_INFO} (a_other)
			orig_c_identifier := a_other.orig_c_identifier -- won't be changed
			storage_class_specifiers := create {TWO_WAY_LIST [INTEGER]}.make
			across a_other.storage_class_specifiers as c loop
				storage_class_specifiers.extend (c.item)
			end
			oo_feature := a_other.oo_feature
		end

invariant
	orig_c_identifier /= Void and then not orig_c_identifier.is_empty
	storage_class_specifiers /= Void

end
