class
	AST_BUILTIN_VA_ARG_CALL

inherit
	AST_EXPRESSION
		rename
			type_binding as type
		end

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_builtin_va_arg_call
		do
			parent := init_parent

			node.children.start
			expression := process_expression (node.children.item, Current)
			node.children.forth
			type := process_type (node.children.item, Current)
		end

feature {ANY}

	expression: AST_EXPRESSION

	type: AST_TYPE

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_builtin_va_arg_call (Current)
			if visit_children then
				visit_node (expression, v)
				visit_node (type, v)
			end
			v.end_visit_builtin_va_arg_call (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			expression := other.expression.ast_twin
			expression.parent := Current
			type := other.type.ast_twin
			type.parent := Current
		end

invariant
	expression /= Void
	type /= Void

end
