class
	AST_COMPOUND_STATEMENT

inherit
	AST_STATEMENT

create
	make,
	make_with_statement,
	make_with_statements,
	make_from_antlr,
	make_copy

feature {NONE}

	make
		do
			create statements.make
		end

	make_with_statement (a_statement: AST_STATEMENT)
		require
			a_statement /= Void and then a_statement.parent = Void
		do
			make
			statements.extend (a_statement)
			a_statement.parent := Current
		end

	make_with_statements (a_statements: ARRAY [AST_STATEMENT])
		require
			a_statements /= Void and then across a_statements as c all c.item /= Void and then c.item.parent = Void end
		do
			make
			across a_statements as c loop
				statements.extend (c.item)
				statements.last.parent := Current
			end
		end

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_compound_statement
		do
			parent := init_parent

			from
				create statements.make
				node.children.start
				node.children.forth -- skip '{'
			until
				node.children.item.type = C_op_close_curly_brace -- skip '}'
			loop
				statements.extend (process_statement (node.children.item, Current))
				node.children.forth
			end
		end

feature {ANY}

	statements: TWO_WAY_LIST [AST_STATEMENT]

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_compound_statement (Current)
			if visit_children then
				visit_list (statements, v)
			end
			v.end_visit_compound_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			create statements.make
			across other.statements as c loop
				statements.extend (c.item.ast_twin)
				statements.last.parent := Current
			end
		end

invariant
	statements /= Void

end
