class
	AST_EIFFEL_JUMP

inherit
	AST_STATEMENT

create
	make,
	make_copy

feature {NONE}

	make (a_state: AST_EIFFEL_JUMP_STATE; a_comment: STRING)
		do
			comment := a_comment
			if a_state /= Void then
				index := a_state.index
			end
		end

feature {ANY}

	index: NATURAL_32_REF

	comment: STRING

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_eiffel_jump (Current)
			if visit_children then
				-- no children
			end
			v.end_visit_eiffel_jump (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			index := other.index
			if other.comment /= Void then
				comment := other.comment.twin
			end
		end

end
