class
	AST_SWITCH_STATEMENT

inherit
	AST_STATEMENT

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = C_kw_switch
		do
			parent := init_parent

			node.children.start
			condition := process_expression (node.children.item, Current)
			node.children.forth
			create statements.make_from_antlr (node.children.item, Current)
		end

feature {ANY}

	condition: AST_EXPRESSION

	statements: AST_COMPOUND_STATEMENT

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_switch_statement (Current)
			if visit_children then
				visit_node (condition, v)
				visit_node (statements, v)
			end
			v.end_visit_switch_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			condition := other.condition.ast_twin
			condition.parent := Current
			statements := other.statements.ast_twin
			statements.parent := Current
		end

invariant
	condition /= Void
	statements /= Void

end
