class
	AST_EIFFEL_STRING_TYPE

inherit
	AST_EIFFEL_TYPE
		redefine
			accept,
			is_equal_type,
			make_copy
		end

create
	make_string,
	make_with_dimension,
	make_copy

feature {ANY} -- Initialization

	make_string
		do
			type_name := "STRING_8"
		end

	make_with_dimension (a_dimension: AST_EXPRESSION)
		require
			a_dimension /= Void implies a_dimension.parent = Void
		do
			make_string
			if a_dimension /= Void then
				dimension := a_dimension
				dimension.parent := Current
			end
		end

feature {ANY}

	dimension: AST_EXPRESSION

feature {ANY} -- AST_EIFFEL_TYPE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_eiffel_string_type (Current)
			if visit_children then
				visit_node (dimension, v)
			end
			v.end_visit_eiffel_string_type (Current)
			v.post_visit (Current)
		end

	is_equal_type (a_type: AST_TYPE): BOOLEAN
		do
			if attached {AST_EIFFEL_STRING_TYPE} a_type as other_type then
				Result := True
			end
		end

	make_copy (other: like Current)
		do
			precursor (other)
			if other.dimension /= Void then
				dimension := other.dimension.ast_twin
				dimension.parent := Current
			end
		end

end
