class
	HASH_SET [G -> HASHABLE]

create
	make

feature {NONE}

	hash_table: HASH_TABLE [ANY, G]

	make (n: INTEGER)
		do
			create hash_table.make (n)
		end

feature {ANY}

	extend (new: G)
			-- adds `new' to the set if it's not already there
		do
			if not has (new) then
				hash_table.extend (Void, new)
			end
		end

	has (elem: G): BOOLEAN
			-- Is `elem' already in the set?
		do
			Result := hash_table.has (elem)
		end

	is_empty: BOOLEAN
		do
			Result := hash_table.is_empty
		end

	wipe_out
		do
			hash_table.wipe_out
		end

	to_array: ARRAY [G]
		do
			Result := hash_table.current_keys
		end

invariant
	hash_table /= Void

end
