class
	CAST_REMOVER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			visit_cast_expression,
			end_visit_cast_expression
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Removing unnecessary casts"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	visit_cast_expression (node: AST_CAST_EXPRESSION): BOOLEAN
		local
			l_cur_cast: AST_CAST_EXPRESSION
		do
			-- remove chained casts: `(foo *)(bar *)fb' -> `(foo *)fb'
			from
				l_cur_cast := node
			until
				not
				(
					attached {AST_CAST_EXPRESSION} l_cur_cast.expression.non_parentheses_expression as tmp and then
					attached {AST_POINTER_TYPE} l_cur_cast.type and then
					attached {AST_POINTER_TYPE} tmp.type
				)
			loop
				l_cur_cast := tmp
			end
			if l_cur_cast /= node then
				replace_node (node.expression, l_cur_cast.expression.ast_twin)
			end
			Result := True
		end

	end_visit_cast_expression (node: AST_CAST_EXPRESSION)
		do
			-- remove unnecessary casts
			if
				node.type.is_equal_type (node.expression.type_binding) or else
				(is_string_type (node.type) and is_string_type (node.expression.type_binding))
			then
				replace_node (node, node.expression.ast_twin)
			end
		end

end
