class
	CHDIR_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_function_call
		end

feature {ANY} -- TRANSFORMATION_STEP

	process (transformer: CODE_TRANSFORMER; error_log: EV_TEXT): BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description : STRING
		do
			Result := "Transforming %"chdir%" to the Eiffel equivalent"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_function_call (node: AST_FUNCTION_CALL)
		local
			cur: AST_NODE
			base_classes: HASH_TABLE [BOOLEAN, STRING]
		do
			if node.identifier.is_equal ("chdir") then
				-- enclosing function needs to be in a class inheriting from EXECUTION_ENVIRONMENT
				from
					cur := node.parent
				until
					attached {AST_FUNCTION_DEFINITION}cur
				loop
					cur := cur.parent
				end
				if attached {HASH_TABLE [BOOLEAN, STRING]}cur.properties["base_classes"] as tmp then
					base_classes := tmp
				else
					create base_classes.make (16)
					cur.properties.extend (base_classes, "base_classes")
				end
				base_classes.extend (True, "EXECUTION_ENVIRONMENT")

				-- "chdir" -> "change_working_directory"
				node.identifier.make_from_string ("change_working_directory")

				-- if result is used, use "return_code"
				if attached {AST_ASSIGNMENT_EXPRESSION}node.parent as assignment_expression then
					insert_statement (get_parent_statement (node), create {AST_EXPRESSION_STATEMENT}.make (clone_node (node)), True)
					replace_expression (node, create {AST_PRIMARY_EXPRESSION}.make_identifier ("return_code"))
				end
			end
		end

end
