class
	ROUTINE_PARAMETER_UTILITIES

feature {ANY}

	change_to_local (a_node: AST_VARIABLE_DECLARATION)
		require
			a_node /= Void
			attached {AST_PARAMETER_LIST} a_node.parent
		local
			l_function: AST_FUNCTION_DECLARATION
			l_params: LIST [AST_NODE]
			l_new_local, l_new_param: AST_VARIABLE_DECLARATION
			l_expression_statement: AST_EXPRESSION_STATEMENT
		do
			l_function ?= a_node.parent.parent
			l_params := l_function.parameter_list.parameters

			-- create new parameter and replace old one
			l_new_param := a_node.ast_twin
			across
				l_params as c
			until
				l_new_param.parent /= Void
			loop
				if c.item = a_node then
					l_new_param.parent := a_node.parent
					l_params.put_i_th (l_new_param, c.target_index)
				end
			end

			-- move orig parameter to local variable (so that bindings still point to the correct variable)
			l_new_local := a_node
			l_new_local.parent := l_function
			l_function.locals.put_front (l_new_local)

			-- create assignment
			create l_expression_statement.make (create {AST_ASSIGNMENT_EXPRESSION}.make (
					create {AST_VARIABLE_EXPRESSION}.make (l_new_local.identifier, l_new_local),
					create {AST_VARIABLE_EXPRESSION}.make (l_new_param.identifier, l_new_param)
				))
			l_expression_statement.parent := l_function.statements
			l_function.statements.statements.put_front (l_expression_statement)
		end

end
