class
	DEPENDENCY_GRAPH_FLAGS

feature {ANY} -- Flags

	External_flag: INTEGER = 1
	Bad_reference_flag: INTEGER = 2
	External_function_flag: INTEGER = 4
	Struct_member_flag: INTEGER = 8
	Union_flag: INTEGER = 16
	Pointer_flag: INTEGER = 32
	Cast_flag: INTEGER = 64
	Function_pointer_flag: INTEGER = 128
	Assignment_flag: INTEGER = 256
	Initializer_flag: INTEGER = 512
	Array_flag: INTEGER = 1024
	Assembler_flag: INTEGER = 2048
	Other_flag: INTEGER = 4096

feature -- output

	flags_to_string (flags: INTEGER): STRING
		do
			create Result.make_empty

			if has_flag (flags, External_flag) then
				Result.append ("extern, ")
			end
			if has_flag (flags, Bad_reference_flag) then
				Result.append ("bad_ref, ")
			end
			if has_flag (flags, External_function_flag) then
				Result.append ("extern_func, ")
			end
			if has_flag (flags, Struct_member_flag) then
				Result.append ("struct_member, ")
			end
			if has_flag (flags, Union_flag) then
				Result.append ("union, ")
			end
			if has_flag (flags, Pointer_flag) then
				Result.append ("pointer_access, ")
			end
			if has_flag (flags, Cast_flag) then
				Result.append ("cast, ")
			end
			if has_flag (flags, Function_pointer_flag) then
				Result.append ("func_pointer, ")
			end
			if has_flag (flags, Assignment_flag) then
				Result.append ("assignment, ")
			end
			if has_flag (flags, Initializer_flag) then
				Result.append ("initializer, ")
			end
			if has_flag (flags, Array_flag) then
				Result.append ("array, ")
			end
			if has_flag (flags, Assembler_flag) then
				Result.append ("assembler, ")
			end
			if has_flag (flags, Other_flag) then
				Result.append ("other, ")
			end

			if not Result.is_empty then
				-- remove last ", "
				Result.remove_tail (2)
			end
		end

	has_flag (flags, test_flag: INTEGER): BOOLEAN
		do
			Result := (flags & test_flag) /= 0
		end

end
